// Introduction to Processing Workshop
//   http://anthonymattox.com/introduction-to-processing-workshop
// Anthony Mattox  /  http://anthonymattox.com  /  @ahmattox

/* Script 3: Basic Animation
   To create animations, a section of code is run for every frame.
   Variables control the position or shapes of shapes we want to animate.
   
   The 'setup()' section of code is run once when the application is
   started and 'draw()' is run every frame. This is the basic structure
   of all processing applications. */
   

float x = 0;  // x position of a shape
float y = 0;  // y position

void setup() {      // run this code when the application starts
  size(300,300);
  stroke(0,0,0);
  strokeWeight(3);
  fill(227, 179, 0);
}

void draw() {          // run this code every frame
  x = x + 1;           // modify the x position every frame
  y = y + 1;           // and y
  
  background(218, 242, 246);  // redraw the background
  rect(x, y, 30, 30);  // draw a shape at (x,y)
}
