// Introduction to Processing Workshop
//   http://anthonymattox.com/introduction-to-processing-workshop
// Anthony Mattox  /  http://anthonymattox.com  /  @ahmattox

/* Script 4: Conditionals
   Conditionals allow us to control more complex actions where one action
   is dependant on the state of another.
   Here, if our box hits the sides of the screen, it's motion changes */



float x = 0;    // the position of our box
float y = 0;
float vx = 3;   // the velocity of our box velocity needs to be a variable
float vy = 4;   // because it will change while the application is running.

void setup() {
  size(300,300);
  stroke(0,0,0);
  strokeWeight(3);
  fill(227, 179, 0);
  smooth();
}

void draw() {
  x = x + vx;       // add the velocity to the position
  y = y + vy;
  if (x>width) {    // if the position is greater than the width of the application
    vx = -3;        // reverse the x velocity (make it negative)
  } else
  if (x<0) {        // if the position is less than 0 (hitting the left side of the screen
    vx = 3;         // make the velocity positive again.
  }
  if (y>height) {   // same thing for the y velocity
    vy = -4;
  } else
  if (y<0) {
    vy = 4;
  }
  
  background(218, 242, 246);
  rect(x, y, 30, 30);   // and draw our box
}
