// Introduction to Processing Workshop
//   http://anthonymattox.com/introduction-to-processing-workshop
// Anthony Mattox  /  http://anthonymattox.com  /  @ahmattox

/* Script 5: Functions
   Functions provide a way to group chunks of code into sectinons which
   can be reused. 'size()', 'fill()', and 'rect()' are functions, but we
   can also create our own with custom behavior, like drawing a face. 
   Functions accept parameters which that control the output, such as the
   x and y position of where to draw the face. */



float x = 20;
float y = 40;
float vx = 2;
float vy = 1;

void setup() {
  size(300,300);
  stroke(0,0,0);
  strokeWeight(3);
  fill(227, 179, 0);
  smooth();
}

void draw() {
  x = x + vx;
  y = y + vy;
  if (x>width-47) {
    vx = -2;
  } else
  if (x<0) {
    vx = 2;
  }
  if (y>height-42) {
    vy = -1;
  } else
  if (y<0) {
    vy = 1;
  }
  
  background(218, 242, 246);
  drawRobotFace(x,y);   // we've replace the 'rect()' function with our own
}

// this function accepts a position and draws a face relative to that position
// we're calling it in the draw function once with our animated x and y values
// It can be called as many times as we want with independant parameters.
void drawRobotFace(float X, float Y) {
  stroke(0,0,0);
  strokeWeight(3);
  fill(227, 179, 0);
  rect(X+0,  Y+0,  47, 42);
  noStroke();
  fill(0,0,0);
  rect(X+9,  Y+19,  6,  6);
  rect(X+35, Y+19,  6,  6);
  rect(X+9,  Y+31, 32,  6);
}
