// Introduction to Processing Workshop
//   http://anthonymattox.com/introduction-to-processing-workshop
// Anthony Mattox  /  http://anthonymattox.com  /  @ahmattox

/* Script 6: Gravity
   Our previous animation script can be easily modified to simulate gravity by
   changing the y velocity every frame as gravity would.
   */

float x = 20;
float y = 40;
float vx = 2;
float vy = 1;

void setup() {
  size(400,400);
  stroke(0,0,0);
  strokeWeight(3);
  fill(227, 179, 0);
  smooth();
}

void draw() {
  vy += .5;      // change the velocity by adding "gravity"
  x = x + vx;    // cahnge the position based on the velocity
  y = y + vy;
  if (x>width-47) {
    vx = -2;
  } else
  if (x<0) {
    vx = 2;
  }
  if (y>height-42) {
    vy = -vy;
    y=height-42;
  }
  
  background(218, 242, 246);
  drawRobotFace(x,y);
}

void drawRobotFace(float X, float Y) {
  stroke(0,0,0);
  strokeWeight(3);
  fill(227, 179, 0);
  rect(X+0,  Y+0,  47, 42);
  noStroke();
  fill(0,0,0);
  rect(X+9,  Y+19,  6,  6);
  rect(X+35, Y+19,  6,  6);
  rect(X+9,  Y+31, 32,  6);
}
