// Introduction to Processing Workshop
//   http://anthonymattox.com/introduction-to-processing-workshop
// Anthony Mattox  /  http://anthonymattox.com  /  @ahmattox

/* Script 7: Mouse Interaction
   Creating interactive scripts is simple. Functions including 'mousePressed()',
   'mouseReleased()', and 'keyPressed()' can be defined and will be called when
   hardware events occur.
   Variables 'mouseX' and 'mouseY' can be used within the draw function to
   access the position of the mouse at any time. */

float x = 20;
float y = 40;
float vx = 2;
float vy = 1;
boolean happy = false; // boolean values are true or false, this tracks if our face is happy

void setup() {
  size(300,300);
  stroke(0,0,0);
  strokeWeight(3);
  fill(227, 179, 0);
}

void draw() {
  x = x + vx;
  y = y + vy;
  if (x>width-47) {
    vx = -2;
  } else
  if (x<0) {
    vx = 2;
  }
  if (y>height-42) {
    vy = -1;
  } else
  if (y<0) {
    vy = 1;
  }
  
  // if the mouse is over the face
  if (mouseX>x && mouseY>y && mouseX<x+47 && mouseY<y+42) {
    happy = true;  // make it happy
  } else {
    happy = false; // otherwise, make it sad (not happy)
  }
  
  background(218, 242, 246);
  drawRobotFace(x,y);
  
  // lets' draw a rectangle at our mouse too
  noStroke();
  fill(17, 82, 25);
  rect(mouseX-5,mouseY-5,10,10);
}

void drawRobotFace(float X, float Y) {
  stroke(0,0,0);
  strokeWeight(3);
  // change the color of our face if it is happy or sad
  if (happy==true) {
    fill(227, 179, 0);
  } else {
    fill(88, 149, 143);
  }
  rect(X+0,  Y+0,  47, 42);
  noStroke();
  fill(0,0,0);
  rect(X+9,  Y+19,  6,  6); // Left Eye
  rect(X+35, Y+19,  6,  6); // Right Eye
  rect(X+9,  Y+31, 32,  6); // Mouth
  // make our face smile our frown if it is happy or sad
  if (happy==true) {
    rect(X+9, Y+29, 5, 2);
    rect(X+36, Y+29, 5, 2);
  } else {
    rect(X+9, Y+36, 5, 2);
    rect(X+36, Y+36, 5, 2);
  }
}

// randomize the velocity of the face when the mouse is pressed
void mousePressed() {
  vx=random(-3,3); // random(min,max) returns a random value in a range
  vy=random(-3,3);
}
