// Introduction to Processing Workshop
//   http://anthonymattox.com/introduction-to-processing-workshop
// Anthony Mattox  /  http://anthonymattox.com  /  @ahmattox

/* Script 8: Loops
   Loops allow you to run a section of code many times. We'll use it to draw
   many robot faces. */

float time = 0;    // we'll add a time variable used to control our animation

void setup() {
  size(500,280);
  stroke(0,0,0);
  strokeWeight(3);
  fill(227, 179, 0);
  smooth();
}

void draw() {
  time = time + 1; // increment the time variable
  
  background(218, 242, 246);
  // Loop!
  // literally it means: for each value of 'i', while 'i' is less than 13,
  // and increment 'i' each time ('i++' means add one to i)
  for (int i=0; i<13; i++) {
    // draw a robot face. The position is controlled by 'i' and 'time'
    // the 'sin()' function is used to create a wave
    drawRobotFace(i*33+28, 120+sin(i-time/30)*20);
  }
}

void drawRobotFace(float X, float Y) {
  stroke(0,0,0);
  strokeWeight(3);
  fill(227, 179, 0);
  rect(X+0,  Y+0,  47, 42);
  noStroke();
  fill(0,0,0);
  rect(X+9,  Y+19,  6,  6);
  rect(X+35, Y+19,  6,  6);
  rect(X+9,  Y+31, 32,  6);
}
