// Introduction to Processing Workshop
//   http://anthonymattox.com/introduction-to-processing-workshop
// Anthony Mattox  /  http://anthonymattox.com  /  @ahmattox

/* Script 9: Arrays
   Arrays hold a series of variables of any type which can be quickly looped through.
   We'll use to arrays to store 'x' and 'y' positions of a series of shapes.
   Each value in the array is accessed by its index. The first value in the array is
   at index 0. */


float[] x = new float[50];  // create an array of 50 floating point numbers
float[] y = new float[50];

void setup() {
  size(400,400);
  for (int i=0; i<x.length; i++) { // loop through our arrays
    // access each value of the array like this ->  arrayName[index]
    x[i] = 0;  // set every value in the arrays initially to 0
    y[i] = 0;  
  }
  
  smooth();
  strokeWeight(3);
  fill(227, 179, 0);
  rectMode(CENTER);
}

void draw() {
  // loop through our arrays so we can shift all the values in the array down one
  for (int i=0; i<x.length-1; i++) {
    x[i] = x[i+1]; // set each value to next index's value
    y[i] = y[i+1];
  }
  x[x.length-1] = mouseX; // set the end of the array to the mouse position
  y[y.length-1] = mouseY;
  
  background(218, 242, 246);
  // loop through our arrays again to draw a rectangle at each point
  for (int i=0; i<x.length; i++) {
    rect(x[i], y[i], i, i);
  }
}
