/* The definition of a type of object is called a class. Each instance of that
   class is an object. Here we'll define our RobotFace class and give it its
   properties and functions. */

class RobotFace {    // a new class called 'RobotFace'
  float x;           // it needs a position and age
  float y;
  float age;
  int munching;      // this variable tracks whether it is animating
  float faceWidth = 47;
  float faceHeight = 42;
  
  // the first method always has the same name as the class and has the same name
  // as the name of the class. It is called to create a new instance of the class.
  // It works like the main 'setup()' function, but for each object.
  RobotFace(float X, float Y) {
    x = X;     // set the parameters of the object to the parameters passsed
    y = Y;     // into the constructor function
    age = 0;
    munching = 0;
  }
  
  // the update function will be called to handle anything that should change
  // every frame of the application
  void update() {
    age++;
    // if the mouse is pressed and it's over this instance, start animating
    if (mousePressed && mouseX>x && mouseY>y && mouseX<x+faceWidth && mouseY<y+faceHeight) {
      munch();
    }
    else
    if (munching>0) {
      // if 'munching' is greater than 0 we should decrement it
      // when it reaches 0 the face will stop animating.
      // animating will happen in the render function when munching > 0
      munching--;
    }
  }
  
  // the 'munch()' function will start the face animating
  void munch() {
    munching = 60;
  }
  
  // the 'render()' function draws the face to the screen
  void render() {
    stroke(0,0,0);
    strokeWeight(3);
    fill(227, 179, 0);
    rect(x+0,  y+0,  47, 42);
    noStroke();
    fill(0,0,0);
    rect(x+9,  y+19,  6,  6);
    rect(x+35, y+19,  6,  6);
    // if munching is > 0, change the shape of the mouth based on 'age'
    if (munching > 0) {
      float m = (sin(age/3)+1)*5+3;
      rect(x+9,  y+34 - m/2, 32, m );
    } else {
      rect(x+9,  y+31, 32,  6);
    }
  }
}
