// Introduction to Processing Workshop
//   http://anthonymattox.com/introduction-to-processing-workshop
// Anthony Mattox  /  http://anthonymattox.com  /  @ahmattox

/* Script 10: Objects!
   Objects are bundles of functions and variables which can be reused many times.
   Like functions, an object can be used to run the same chunk of code many times, but
   additionally, each instance has it's own variables.
   
   We'll create an object for our robot face. It will have variables to represent its 
   properties, such as position and if it's animating, and functions (or methods) to
   define it's actions such as to draw itself or start animating. */

RobotFace robotFace1;  // instances of our RobotFace class are created like any other
RobotFace robotFace2;  // variables, but the type is 'RobotFace'
RobotFace robotFace3;

void setup() {
  size(400,400);
  smooth();
  
  robotFace1 = new RobotFace(100,100); // to create a new instance, use the new keyword
  robotFace2 = new RobotFace(250,100); // and call the constructor function, explained
  robotFace3 = new RobotFace(200,300); // in the RobotFace object
}

void draw() {
  robotFace1.update();   // to call the methods of an object, write the name of the
  robotFace2.update();   // variable, followed by a dot and the function name
  robotFace3.update();   // here we update all the faces
  
  background(218, 242, 246);
  robotFace1.render();   // and here we render them
  robotFace2.render();
  robotFace3.render();
}
