// Introduction to Processing Workshop
//   http://anthonymattox.com/introduction-to-processing-workshop
// Anthony Mattox  /  http://anthonymattox.com  /  @ahmattox

/* Script 11: Arrays of Objects:
   Like other variables, objects can be stored in arrays. Here we'll create an array
   of our face objects. Each will behave independantly based on the same rules.*/


// create an array of our objects
RobotFace[] robotFaces = new RobotFace[10];

void setup() {
  size(400,400);
  smooth();
  
  // set each variable in our array to a new robot face at the center of the screen
  for (int i=0; i<robotFaces.length; i++) {
    robotFaces[i] = new RobotFace(width/2, height/2);
  }
}

void draw() {
  // update all our objects
  for (int i=0; i<robotFaces.length; i++) {
    robotFaces[i].update();
  }
  
  background(218, 242, 246);
  // render all our objects
  for (int i=0; i<robotFaces.length; i++) {
    robotFaces[i].render();
  }
}
